package com.ynet.life.action;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.life.base.LifeAction;
import com.ynet.life.base.Trace;
import java.text.SimpleDateFormat;
import java.util.Calendar;

/* loaded from: com_ynet_life_action.jar:com/ynet/life/action/CountScheduleNextDate.class */
public class CountScheduleNextDate extends LifeAction {
    private String cycleField = null;
    private String monthDayField = null;
    private String weekDayField = null;
    private String startDateField = null;
    private String endDateField = null;
    private String nextDateField = null;

    public String execute(Context context) throws GENEException {
        Calendar compareCalendar;
        String cycle = (String) context.get(this.cycleField);
        String monthDay = (String) context.get(this.monthDayField);
        String weekDay = (String) context.get(this.weekDayField);
        String startDate = (String) context.get(this.startDateField);
        String endDate = (String) context.get(this.endDateField);
        try {
            Calendar todayCalendar = Calendar.getInstance();
            SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd");
            Calendar startCalendar = (Calendar) todayCalendar.clone();
            startCalendar.setTime(formatter.parse(startDate));
            if (todayCalendar.compareTo(startCalendar) < 0) {
                compareCalendar = startCalendar;
            } else {
                todayCalendar.add(5, 1);
                compareCalendar = todayCalendar;
            }
            Calendar nextCalendar = (Calendar) compareCalendar.clone();
            if ("1".equals(cycle)) {
                nextCalendar.set(7, Integer.parseInt(weekDay));
                if (compareCalendar.compareTo(nextCalendar) > 0) {
                    nextCalendar.add(5, 7);
                }
            } else if ("2".equals(cycle)) {
                nextCalendar.set(5, Integer.parseInt(monthDay));
                if (compareCalendar.compareTo(nextCalendar) > 0) {
                    nextCalendar.add(2, 1);
                }
            }
            String format = formatter.format(nextCalendar.getTime());
            String nextDate = format;
            if (format.compareTo(endDate) > 0) {
                nextDate = "00000000";
            }
            context.put(this.nextDateField, nextDate);
            return "0";
        } catch (Exception e) {
            Trace.logError("LifeAction", e.getMessage(), e);
            throw new GENEException(e);
        }
    }

    public void setCycleField(String cycleField) {
        this.cycleField = cycleField;
    }

    public void setMonthDayField(String monthDayField) {
        this.monthDayField = monthDayField;
    }

    public void setWeekDayField(String weekDayField) {
        this.weekDayField = weekDayField;
    }

    public void setStartDateField(String startDateField) {
        this.startDateField = startDateField;
    }

    public void setEndDateField(String endDateField) {
        this.endDateField = endDateField;
    }

    public void setNextDateField(String nextDateField) {
        this.nextDateField = nextDateField;
    }
}
